# This file is generated by SciPy's build process
# It contains system_info results at the time of building this package.
from enum import Enum

__all__ = ["show"]
_built_with_meson = True


class DisplayModes(Enum):
    stdout = "stdout"
    dicts = "dicts"


def _cleanup(d):
    """
    Removes empty values in a `dict` recursively
    This ensures we remove values that Meson could not provide to CONFIG
    """
    if isinstance(d, dict):
        return { k: _cleanup(v) for k, v in d.items() if v != '' and _cleanup(v) != '' }
    else:
        return d


CONFIG = _cleanup(
    {
        "Compilers": {
            "c": {
                "name": "gcc",
                "linker": r"ld.bfd",
                "version": "13.2.0",
                "commands": r"armv7l-linux-musleabihf-gcc",
                "args": r"-fstack-clash-protection, -D_FORTIFY_SOURCE=2, -O2, -pipe, -march=armv7-a, -mfpu=vfpv3, -mfloat-abi=hard, -g, -I/usr/armv7l-linux-musleabihf/usr/lib/python3.13/site-packages/numpy/_core/include, -I/usr/armv7l-linux-musleabihf/usr/include/python3.13, -I/usr/armv7l-linux-musleabihf/usr/include, -I/usr/armv7l-linux-musleabihf/usr/include, -ffile-prefix-map=/builddir/python3-scipy-1.15.2=.",
                "linker args": r"-Wl,-z,relro, -Wl,-z,now, -Wl,--as-needed, -L/usr/armv7l-linux-musleabihf/usr/lib/python3.13/site-packages/numpy/_core/lib, -L/usr/armv7l-linux-musleabihf/usr/lib/python3.13/site-packages/numpy/random/lib, -L/usr/armv7l-linux-musleabihf/usr/lib/python3.13, -L/usr/armv7l-linux-musleabihf/usr/lib, -L/usr/armv7l-linux-musleabihf/usr/lib, -fstack-clash-protection, -D_FORTIFY_SOURCE=2, -O2, -pipe, -march=armv7-a, -mfpu=vfpv3, -mfloat-abi=hard, -g, -I/usr/armv7l-linux-musleabihf/usr/lib/python3.13/site-packages/numpy/_core/include, -I/usr/armv7l-linux-musleabihf/usr/include/python3.13, -I/usr/armv7l-linux-musleabihf/usr/include, -I/usr/armv7l-linux-musleabihf/usr/include, -ffile-prefix-map=/builddir/python3-scipy-1.15.2=.",
            },
            "cython": {
                "name": r"cython",
                "linker": r"cython",
                "version": r"3.0.12",
                "commands": r"cython",
                "args": r"",
                "linker args": r"",
            },
            "c++": {
                "name": "gcc",
                "linker": r"ld.bfd",
                "version": "13.2.0",
                "commands": r"armv7l-linux-musleabihf-c++",
                "args": r"-fstack-clash-protection, -D_FORTIFY_SOURCE=2, -O2, -pipe, -march=armv7-a, -mfpu=vfpv3, -mfloat-abi=hard, -g, -I/usr/armv7l-linux-musleabihf/usr/include/python3.13, -I/usr/armv7l-linux-musleabihf/usr/include, -I/usr/armv7l-linux-musleabihf/usr/include, -ffile-prefix-map=/builddir/python3-scipy-1.15.2=.",
                "linker args": r"-Wl,-z,relro, -Wl,-z,now, -Wl,--as-needed, -L/usr/armv7l-linux-musleabihf/usr/lib/python3.13/site-packages/numpy/_core/lib, -L/usr/armv7l-linux-musleabihf/usr/lib/python3.13/site-packages/numpy/random/lib, -L/usr/armv7l-linux-musleabihf/usr/lib/python3.13, -L/usr/armv7l-linux-musleabihf/usr/lib, -L/usr/armv7l-linux-musleabihf/usr/lib, -fstack-clash-protection, -D_FORTIFY_SOURCE=2, -O2, -pipe, -march=armv7-a, -mfpu=vfpv3, -mfloat-abi=hard, -g, -I/usr/armv7l-linux-musleabihf/usr/include/python3.13, -I/usr/armv7l-linux-musleabihf/usr/include, -I/usr/armv7l-linux-musleabihf/usr/include, -ffile-prefix-map=/builddir/python3-scipy-1.15.2=.",
            },
            "fortran": {
                "name": "gcc",
                "linker": r"ld.bfd",
                "version": "13.2.0",
                "commands": r"armv7l-linux-musleabihf-gfortran",
                "args": r"-fstack-clash-protection, -O2, -pipe, -march=armv7-a, -mfpu=vfpv3, -mfloat-abi=hard, -g",
                "linker args": r"-Wl,-z,relro, -Wl,-z,now, -Wl,--as-needed, -L/usr/armv7l-linux-musleabihf/usr/lib/python3.13/site-packages/numpy/_core/lib, -L/usr/armv7l-linux-musleabihf/usr/lib/python3.13/site-packages/numpy/random/lib, -L/usr/armv7l-linux-musleabihf/usr/lib/python3.13, -L/usr/armv7l-linux-musleabihf/usr/lib, -L/usr/armv7l-linux-musleabihf/usr/lib, -fstack-clash-protection, -O2, -pipe, -march=armv7-a, -mfpu=vfpv3, -mfloat-abi=hard, -g",
            },
            "pythran": {
                "version": r"0.17.0",
                "include directory": r"/usr/armv7l-linux-musleabihf/usr/lib/python3.13/site-packages/pythran"
            },
        },
        "Machine Information": {
            "host": {
                "cpu": r"armv7l",
                "family": r"arm",
                "endian": r"little",
                "system": r"linux",
            },
            "build": {
                "cpu": r"x86_64",
                "family": r"x86_64",
                "endian": r"little",
                "system": r"linux",
            },
            "cross-compiled": bool("True".lower().replace('false', '')),
        },
        "Build Dependencies": {
            "blas": {
                "name": "openblas",
                "found": bool("True".lower().replace('false', '')),
                "version": "0.3.29",
                "detection method": "pkgconfig",
                "include directory": r"/usr/include/openblas",
                "lib directory": r"/usr/lib",
                "openblas configuration": r"USE_64BITINT= DYNAMIC_ARCH= DYNAMIC_OLDER= NO_CBLAS= NO_LAPACK= NO_LAPACKE= NO_AFFINITY=1 USE_OPENMP=1 ARMV7 MAX_THREADS=6",
                "pc file directory": r"/usr/armv7l-linux-musleabihf/usr/lib/pkgconfig",
            },
            "lapack": {
                "name": "openblas",
                "found": bool("True".lower().replace('false', '')),
                "version": "0.3.29",
                "detection method": "pkgconfig",
                "include directory": r"/usr/include/openblas",
                "lib directory": r"/usr/lib",
                "openblas configuration": r"USE_64BITINT= DYNAMIC_ARCH= DYNAMIC_OLDER= NO_CBLAS= NO_LAPACK= NO_LAPACKE= NO_AFFINITY=1 USE_OPENMP=1 ARMV7 MAX_THREADS=6",
                "pc file directory": r"/usr/armv7l-linux-musleabihf/usr/lib/pkgconfig",
            },
            "pybind11": {
                "name": "pybind11",
                "version": "2.13.6",
                "detection method": "pkgconfig",
                "include directory": r"/usr/armv7l-linux-musleabihf/usr/share/pkgconfig/../..//include",
            },
        },
        "Python Information": {
            "path": r"/usr/bin/python3",
            "version": "3.13",
        },
    }
)


def _check_pyyaml():
    import yaml

    return yaml


def show(mode=DisplayModes.stdout.value):
    """
    Show libraries and system information on which SciPy was built
    and is being used

    Parameters
    ----------
    mode : {`'stdout'`, `'dicts'`}, optional.
        Indicates how to display the config information.
        `'stdout'` prints to console, `'dicts'` returns a dictionary
        of the configuration.

    Returns
    -------
    out : {`dict`, `None`}
        If mode is `'dicts'`, a dict is returned, else None

    Notes
    -----
    1. The `'stdout'` mode will give more readable
       output if ``pyyaml`` is installed

    """
    if mode == DisplayModes.stdout.value:
        try:  # Non-standard library, check import
            yaml = _check_pyyaml()

            print(yaml.dump(CONFIG))
        except ModuleNotFoundError:
            import warnings
            import json

            warnings.warn("Install `pyyaml` for better output", stacklevel=1)
            print(json.dumps(CONFIG, indent=2))
    elif mode == DisplayModes.dicts.value:
        return CONFIG
    else:
        raise AttributeError(
            f"Invalid `mode`, use one of: {', '.join([e.value for e in DisplayModes])}"
        )
